(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("lodash"));
	else if(typeof define === 'function' && define.amd)
		define(["lodash"], factory);
	else if(typeof exports === 'object')
		exports["whynomatch"] = factory(require("lodash"));
	else
		root["whynomatch"] = factory(root["_"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

	var _lodash = __webpack_require__(1);

	var _lodash2 = _interopRequireDefault(_lodash);

	var _mongo_parsing_error = __webpack_require__(2);

	var _mongo_parsing_error2 = _interopRequireDefault(_mongo_parsing_error);

	var _deepEqual = __webpack_require__(3);

	var _deepEqual2 = _interopRequireDefault(_deepEqual);

	var comparisionOperators = {
	  $eq: function $eq(target, value) {
	    return target === value;
	  },
	  $gt: function $gt(target, value) {
	    return target > value;
	  },
	  $gte: function $gte(target, value) {
	    return target >= value;
	  },
	  $lt: function $lt(target, value) {
	    return target < value;
	  },
	  $lte: function $lte(target, value) {
	    return target <= value;
	  },
	  $ne: function $ne(target, value) {
	    return target !== value;
	  },
	  $exists: function $exists(target, value) {
	    return target !== undefined == value;
	  },
	  $mod: function $mod(target, value) {
	    if (!_lodash2["default"].isArray(value) || value.length !== 2) throw new _mongo_parsing_error2["default"]("mod", "array of size 2: [dividor, reminder]", value);

	    var divisor = value[0];
	    var reminder = value[1];

	    return target % divisor === reminder;
	  },
	  $regex: function $regex(target, value) {
	    if (!_lodash2["default"].isString(value) && !_lodash2["default"].isRegExp(value)) throw new _mongo_parsing_error2["default"]("regex", "RegExp or a string", value);

	    return new RegExp(value).test(target);
	  },
	  $shortEq: function $shortEq(target, value, key) {
	    if (_lodash2["default"].isRegExp(value)) {
	      return value.test(target);
	    } else {
	      return (0, _deepEqual2["default"])(value, target, { strictOrder: true });
	    }
	  }
	};

	var arrayOperators = {
	  $in: function $in(target, value) {
	    if (!_lodash2["default"].isArray(value)) throw new _mongo_parsing_error2["default"]("in", "array", value);

	    if (!_lodash2["default"].isArray(target)) {
	      target = [target];
	    }

	    var match = comparisionOperators.$shortEq;

	    for (var i in target) {
	      var curTarget = target[i];
	      for (var j in value) {
	        var curValue = value[j];

	        if (match(curTarget, curValue)) {
	          return true;
	        }
	      }
	    }

	    return false;
	  },
	  $nin: function $nin(target, value) {
	    return !arrayOperators["$in"](target, value);
	  },
	  $all: function $all(target, value) {
	    if (!_lodash2["default"].isArray(value)) throw new _mongo_parsing_error2["default"]("$all", "Array", value);
	    if (!_lodash2["default"].isArray(target)) {
	      target = [target];
	    }
	    return (0, _lodash2["default"])(value).difference(target).isEmpty();
	  },
	  $size: function $size(target, value) {
	    if (!_lodash2["default"].isNumber(value)) throw new _mongo_parsing_error2["default"]("size", "number", value);
	    if (!_lodash2["default"].isArray(target)) return false;

	    return target.length === value;
	  }
	};

	var lowLevelOperators = _lodash2["default"].extend(wrapComperisionOperators(comparisionOperators, true), wrapComperisionOperators(arrayOperators), {
	  $not: function $not(target, value, key) {
	    var result = lowLevelWhynomatch(target, value);
	    if (_lodash2["default"].isEmpty(result)) return value;else return {};
	  },
	  $elemMatch: function $elemMatch(target, value, key) {
	    if (!_lodash2["default"].isPlainObject(value)) throw new _mongo_parsing_error2["default"]("elemMatch", "object", value);

	    if (!_lodash2["default"].isArray(target)) return value;

	    var subQueriesResults = (0, _lodash2["default"])(target).map(_lodash2["default"].partial(elemMatchLevelWhynomatch, _lodash2["default"], value)).reject(_lodash2["default"].partial(_lodash2["default"].isEqual, {})).value();

	    if (subQueriesResults.length === target.length) {
	      return value;
	    }

	    return {};
	  } });

	var topLevelOperators = {
	  $or: function $or(target, value, key) {
	    var subQueriesResults = multiOperator(target, value, key);

	    if (subQueriesResults.length === value.length) return value;

	    return {};
	  },
	  $and: function $and(target, value, key) {
	    var subQueriesResults = multiOperator(target, value, key);

	    if (subQueriesResults.length > 0) return subQueriesResults;

	    return {};
	  },
	  $nor: function $nor(target, value, key) {
	    var subQueriesResults = multiOperator(target, value, key);

	    if (subQueriesResults.length !== value.length) return value;

	    return {};
	  },
	  $where: function $where(target, value) {
	    var fn = undefined;

	    if (_lodash2["default"].isFunction(value)) {
	      fn = value;
	    } else if (_lodash2["default"].isString(value)) {
	      eval("fn = function(){var obj = this; return " + value + "}");
	    } else {
	      throw new _mongo_parsing_error2["default"]("where", "function or a string", value);
	    }

	    if (!fn.call(target)) return value;
	  }
	};

	function whynomatch(target, query) {
	  return topLevelWhynomatch(target, query);
	}

	function topLevelWhynomatch(target, query) {
	  var noMatch = {};

	  _lodash2["default"].keys(query).forEach(function (key) {
	    validateOperator(key, isTopLevelOperator);

	    var value = query[key];
	    var results = undefined;

	    if (isTopLevelOperator(key)) {
	      var operator = getTopLevelOperator(key, value);
	      results = operator(target, value, key);
	    } else {
	      var nestedTarget = _lodash2["default"].property(key)(target);
	      results = lowLevelWhynomatch(nestedTarget, value);
	    }

	    if (!isEmpty(results)) noMatch[key] = results;
	  });

	  return noMatch;
	}

	function lowLevelWhynomatch(target, query) {
	  var noMatch = {};

	  if (!isMongoExpression(query)) {
	    noMatch = lowLevelOperators.$shortEq(target, query);
	    return noMatch;
	  }

	  _lodash2["default"].keys(query).forEach(function (key) {
	    validateOperator(key, isLowLevelOperator);

	    var value = query[key];

	    var operator = getLowLevelOperator(key, value);
	    var operatorResults = operator(target, value, key);

	    if (!isEmpty(operatorResults)) noMatch[key] = operatorResults;
	  });

	  return noMatch;
	}

	function elemMatchLevelWhynomatch(target, query) {
	  var noMatch = {};

	  _lodash2["default"].keys(query).forEach(function (key) {
	    validateOperator(key, function (key) {
	      return key !== "$where" && (isLowLevelOperator(key) || isTopLevelOperator(key));
	    });

	    var value = query[key];
	    var results = undefined;

	    if (isTopLevelOperator(key)) {
	      var operator = getTopLevelOperator(key, value);
	      results = operator(target, value, key);
	    } else if (isLowLevelOperator(key)) {
	      var operator = getLowLevelOperator(key, value);
	      results = operator(target, value, key);
	    } else {
	      var nestedTarget = _lodash2["default"].property(key)(target);
	      results = lowLevelWhynomatch(nestedTarget, value);
	    }

	    if (!isEmpty(results)) noMatch[key] = results;
	  });

	  return noMatch;
	}

	function isMongoExpression(query) {
	  return !isPrimitive(query) && (0, _lodash2["default"])(query).keys().all(looksLikeOperator);
	}

	function isPrimitive(query) {
	  return _lodash2["default"].isString(query) || _lodash2["default"].isNumber(query) || _lodash2["default"].isDate(query) || _lodash2["default"].isArray(query) || _lodash2["default"].isBoolean(query) || _lodash2["default"].isRegExp(query);
	}

	function getTopLevelOperator(key, value) {
	  return topLevelOperators[key];
	}

	function getLowLevelOperator(key, value) {
	  return lowLevelOperators[key];
	}

	function isTopLevelOperator(operator) {
	  return operator in topLevelOperators;
	}

	function isLowLevelOperator(operator) {
	  return operator in lowLevelOperators;
	}

	function validateOperator(key, checkFn) {
	  if (looksLikeOperator(key) && !checkFn(key)) {
	    throw new Error(key + " is not a legal operator at this location");
	  }
	}

	function looksLikeOperator(key) {
	  return /^\$.+/.test(key);
	}

	function isEmpty(value) {
	  return value == undefined || _lodash2["default"].isEqual(value, {});
	}

	function multiOperator(target, subQueries, key) {
	  if (!_lodash2["default"].isArray(subQueries) || subQueries.length === 0) throw new _mongo_parsing_error2["default"](key, "Array", subQueries);

	  var subQueriesResults = (0, _lodash2["default"])(subQueries).map(_lodash2["default"].partial(topLevelWhynomatch, target)).reject(_lodash2["default"].partial(_lodash2["default"].isEqual, {})).value();

	  return subQueriesResults;
	}

	function wrapComperisionOperators(operators) {
	  var arrayEquality = arguments[1] === undefined ? false : arguments[1];

	  return _lodash2["default"].transform(operators, function (result, operatorFn, operatorName) {
	    var wrapedOperator = wrapComperisionOperator(operatorFn, arrayEquality);
	    result[operatorName] = wrapedOperator;
	  });
	}

	function wrapComperisionOperator(operatorFn, arrayEquality) {
	  return function (target, value, key) {
	    if (arrayEquality && _lodash2["default"].isArray(target)) {
	      if (!_lodash2["default"].some(target, _lodash2["default"].partial(operatorFn, _lodash2["default"], value, key))) return value;

	      return {};
	    } else if (!operatorFn(target, value, key)) {
	      return value;
	    }

	    return {};
	  };
	}

	exports["default"] = whynomatch;
	module.exports = exports["default"];

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";

	var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

	var MongoParsingError = (function (_Error) {
	  function MongoParsingError(operator, expected, recived) {
	    _classCallCheck(this, MongoParsingError);

	    var message = operator + " operator must recieve a " + expected + ". Got: " + recived;
	    _get(Object.getPrototypeOf(MongoParsingError.prototype), "constructor", this).call(this, message);
	    this.name = this.constructor.name;
	    this.message = message;
	    Error.captureStackTrace(this, this.constructor.name);
	  }

	  _inherits(MongoParsingError, _Error);

	  return MongoParsingError;
	})(Error);

	module.exports = MongoParsingError;

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	var pSlice = Array.prototype.slice;
	var objectKeys = __webpack_require__(4);
	var isArguments = __webpack_require__(5);

	var deepEqual = module.exports = function (actual, expected, opts) {
	  if (!opts) opts = {};
	  // 7.1. All identical values are equivalent, as determined by ===.
	  if (actual === expected) {
	    return true;

	  } else if (actual instanceof Date && expected instanceof Date) {
	    return actual.getTime() === expected.getTime();

	  // 7.3. Other pairs that do not both pass typeof value == 'object',
	  // equivalence is determined by ==.
	  } else if (!actual || !expected || typeof actual != 'object' && typeof expected != 'object') {
	    return opts.strict ? actual === expected : actual == expected;

	  // 7.4. For all other Object pairs, including Array objects, equivalence is
	  // determined by having the same number of owned properties (as verified
	  // with Object.prototype.hasOwnProperty.call), the same set of keys
	  // (although not necessarily the same order), equivalent values for every
	  // corresponding key, and an identical 'prototype' property. Note: this
	  // accounts for both named and indexed properties on Arrays.
	  } else {
	    return objEquiv(actual, expected, opts);
	  }
	}

	function isUndefinedOrNull(value) {
	  return value === null || value === undefined;
	}

	function isBuffer (x) {
	  if (!x || typeof x !== 'object' || typeof x.length !== 'number') return false;
	  if (typeof x.copy !== 'function' || typeof x.slice !== 'function') {
	    return false;
	  }
	  if (x.length > 0 && typeof x[0] !== 'number') return false;
	  return true;
	}

	function objEquiv(a, b, opts) {
	  var i, key;
	  if (isUndefinedOrNull(a) || isUndefinedOrNull(b))
	    return false;
	  // an identical 'prototype' property.
	  if (a.prototype !== b.prototype) return false;
	  //~~~I've managed to break Object.keys through screwy arguments passing.
	  //   Converting to array solves the problem.
	  if (isArguments(a)) {
	    if (!isArguments(b)) {
	      return false;
	    }
	    a = pSlice.call(a);
	    b = pSlice.call(b);
	    return deepEqual(a, b, opts);
	  }
	  if (isBuffer(a)) {
	    if (!isBuffer(b)) {
	      return false;
	    }
	    if (a.length !== b.length) return false;
	    for (i = 0; i < a.length; i++) {
	      if (a[i] !== b[i]) return false;
	    }
	    return true;
	  }
	  try {
	    var ka = objectKeys(a),
	        kb = objectKeys(b);
	  } catch (e) {//happens when one is a string literal and the other isn't
	    return false;
	  }
	  // having the same number of owned properties (keys incorporates
	  // hasOwnProperty)
	  if (ka.length != kb.length)
	    return false;
	  //the same set of keys (although not necessarily the same order),

	  if(!opts.strictOrder){
	    ka.sort();
	    kb.sort();
	  }
	  
	  //~~~cheap key test
	  for (i = ka.length - 1; i >= 0; i--) {
	    if (ka[i] != kb[i])
	      return false;
	  }
	  //equivalent values for every corresponding key, and
	  //~~~possibly expensive deep test
	  for (i = ka.length - 1; i >= 0; i--) {
	    key = ka[i];
	    if (!deepEqual(a[key], b[key], opts)) return false;
	  }
	  return typeof a === typeof b;
	}


/***/ },
/* 4 */
/***/ function(module, exports) {

	exports = module.exports = typeof Object.keys === 'function'
	  ? Object.keys : shim;

	exports.shim = shim;
	function shim (obj) {
	  var keys = [];
	  for (var key in obj) keys.push(key);
	  return keys;
	}


/***/ },
/* 5 */
/***/ function(module, exports) {

	var supportsArgumentsClass = (function(){
	  return Object.prototype.toString.call(arguments)
	})() == '[object Arguments]';

	exports = module.exports = supportsArgumentsClass ? supported : unsupported;

	exports.supported = supported;
	function supported(object) {
	  return Object.prototype.toString.call(object) == '[object Arguments]';
	};

	exports.unsupported = unsupported;
	function unsupported(object){
	  return object &&
	    typeof object == 'object' &&
	    typeof object.length == 'number' &&
	    Object.prototype.hasOwnProperty.call(object, 'callee') &&
	    !Object.prototype.propertyIsEnumerable.call(object, 'callee') ||
	    false;
	};


/***/ }
/******/ ])
});
;